import type { HistoricalPricesOptions, HistoricalPricesResponse } from './types/historicalPrices';
import type { getSymbolResponse } from './types/getSymbol';
declare class YahooStockAPI {
    private frequencyList;
    private requestPool;
    getHistoricalPrices({ startDate, endDate, symbol, frequency }: HistoricalPricesOptions): Promise<APIresponse | {
        error: boolean;
        message: unknown;
    }>;
    getSymbol({ symbol }: {
        symbol: string;
    }): Promise<APIresponse | {
        error: boolean;
        message: unknown;
    }>;
    private getSymbolMapRows;
    private handleError;
    private handleResponse;
    private parseCol1;
    private parseCol2;
}
declare type APIresponse = {
    error: boolean;
    currency: string | null | undefined;
    response: HistoricalPricesResponse[] | getSymbolResponse;
};
export default YahooStockAPI;
